Index: /extensions/UserCollections/admin.php
===================================================================
--- /extensions/UserCollections/admin.php	(revision 25677)
+++ /extensions/UserCollections/admin.php	(revision 25678)
@@ -8,5 +8,5 @@
 include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
 $page['tab'] = (isset($_GET['tab'])) ? $_GET['tab'] : 'sets';
-  
+
 $tabsheet = new tabsheet();
 $tabsheet->add('sets', l10n('Collections'), USER_COLLEC_ADMIN . '-sets');
@@ -34,6 +34,4 @@
   'USER_COLLEC_ADMIN' => USER_COLLEC_ADMIN,
   ));
-  
+
 $template->assign_var_from_handle('ADMIN_CONTENT', 'user_collections');
-
-?>
Index: /extensions/UserCollections/admin/config.php
===================================================================
--- /extensions/UserCollections/admin/config.php	(revision 25677)
+++ /extensions/UserCollections/admin/config.php	(revision 25678)
@@ -8,5 +8,5 @@
     'allow_mails'     => isset($_POST['allow_mails']) && isset($_POST['allow_public']),
     );
-  
+
   conf_update_param('user_collections', serialize($conf['user_collections']));
 }
@@ -18,4 +18,2 @@
 
 $template->set_filename('user_collections', realpath(USER_COLLEC_PATH . 'admin/template/config.tpl'));
-
-?>
Index: /extensions/UserCollections/admin/export.php
===================================================================
--- /extensions/UserCollections/admin/export.php	(revision 25677)
+++ /extensions/UserCollections/admin/export.php	(revision 25678)
@@ -4,5 +4,5 @@
 try {
   $collection = new UserCollection($_GET['col_id']);
-  
+
   $template->assign('COL_ID', $_GET['col_id']);
 }
@@ -19,8 +19,8 @@
   pwg_set_session_var('uc_export_active_fields', $_POST['active']);
   pwg_set_session_var('uc_export_inactive_fields', $_POST['inactive']);
-  
+
   $content = $collection->serialize($_POST['active']);
   $filename = 'collection_'.$_GET['col_id'].'_'.date('Ymd-Hi').'.csv';
-  
+
   header('Content-Type: application/force-download; name="'.$filename.'"');
   header('Content-Disposition: attachment; filename="'.$filename.'"');
@@ -32,5 +32,5 @@
   header('Pragma: no-cache');
   header('Expires: 0');
-  
+
   echo $content;
   exit;
@@ -55,5 +55,4 @@
 $template->assign('inactive_fields', pwg_get_session_var('uc_export_inactive_fields', $default_inactive_fields));
 
+
 $template->set_filename('user_collections', realpath(USER_COLLEC_PATH . 'admin/template/export.tpl'));
-
-?>
Index: /extensions/UserCollections/admin/index.php
===================================================================
--- /extensions/UserCollections/admin/index.php	(revision 25677)
+++ /extensions/UserCollections/admin/index.php	(revision 25678)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based photo gallery                                    |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
@@ -28,3 +5,2 @@
 header( 'Location: '.$url );
 exit();
-?>
Index: /extensions/UserCollections/admin/sets.php
===================================================================
--- /extensions/UserCollections/admin/sets.php	(revision 25677)
+++ /extensions/UserCollections/admin/sets.php	(revision 25678)
@@ -19,10 +19,10 @@
     array_push($where_clauses, 'username LIKE "%'.$_POST['username'].'%"');
   }
-  
+
   if (!empty($_POST['name']))
   {
     array_push($where_clauses, 'name LIKE "%'.$_POST['name'].'%"');
   }
-  
+
   $order_by = $_POST['order_by'].' '.$_POST['direction'];
 }
@@ -31,5 +31,5 @@
 // get sets
 $query = '
-SELECT 
+SELECT
     c.*,
     u.'.$conf['user_fields']['username'].' AS username
@@ -46,5 +46,5 @@
 {
   $template->append('sets', array(
-    'NAME' => trigger_event('render_category_name', $row['name']),
+    'NAME' => trigger_change('render_category_name', $row['name']),
     'NB_IMAGES' => $row['nb_images'],
     'DATE_CREATION' => format_date($row['date_creation'], true),
@@ -74,5 +74,5 @@
   'direction_options' => $page['direction_items'],
   'direction_selected' => isset($_POST['direction']) ? $_POST['direction'] : '',
-  
+
   'F_USERNAME' => @htmlentities($_POST['username'], ENT_COMPAT, 'UTF-8'),
   'F_NAME' => @htmlentities($_POST['name'], ENT_COMPAT, 'UTF-8'),
@@ -82,4 +82,2 @@
 
 $template->set_filename('user_collections', realpath(USER_COLLEC_PATH . 'admin/template/sets.tpl'));
-
-?>
Index: /extensions/UserCollections/include/UserCollection.class.php
===================================================================
--- /extensions/UserCollections/include/UserCollection.class.php	(revision 25677)
+++ /extensions/UserCollections/include/UserCollection.class.php	(revision 25678)
@@ -6,19 +6,23 @@
   private $data;
   private $images;
-  
+
   /**
    * __construct
-   * @param: mixed col id (##|'new')
-   * @param: array images
+   * @throws Exception
+   *
+   * @param int|string $col_id or 'new'
+   * @param string $name
+   * @param string $comment
+   * @param int $user_id
    */
   function __construct($col_id, $name=null, $comment=null, $user_id=null)
   {
     global $user;
-    
+
     if (empty($user_id))
     {
       $user_id = $user['id'];
     }
-    
+
     $this->data = array(
       'id' => 0,
@@ -30,5 +34,5 @@
       );
     $this->images = array();
-    
+
     // load specific collection
     if (preg_match('#^[0-9]+$#', $col_id))
@@ -40,5 +44,5 @@
 ;';
       $result = pwg_query($query);
-      
+
       if (pwg_db_num_rows($result))
       {
@@ -47,5 +51,5 @@
           pwg_db_fetch_assoc($result)
           );
-        
+
         // make sure all pictures of the collection exist
         $query = '
@@ -56,5 +60,5 @@
 ;';
         pwg_query($query);
-      
+
         // select images of the collection
         $query = '
@@ -64,5 +68,5 @@
 ;';
         $this->images = array_from_query($query, 'image_id');
-        
+
         $this->updateParam('nb_images', count($this->images));
       }
@@ -77,5 +81,5 @@
       $this->data['name'] = $name;
       $this->data['comment'] = $comment;
-      
+
       $query = '
 INSERT INTO '.COLLECTIONS_TABLE.'(
@@ -84,5 +88,5 @@
     date_creation,
     comment
-  ) 
+  )
   VALUES(
     '.$this->data['user_id'].',
@@ -94,5 +98,5 @@
       pwg_query($query);
       $this->data['id'] = pwg_db_insert_id();
-      
+
       $date = pwg_query('SELECT NOW();');
       list($this->data['date_creation']) = pwg_db_fetch_row($date);
@@ -103,12 +107,13 @@
     }
   }
-  
-  /**
-   * check if current user is owner of the collection or admin
+
+  /**
+   * Check if current user is owner of the collection or admin
+   * @throws Exception
    */
   function checkUser()
   {
     global $user;
-    
+
     if (!is_admin() && $user['id'] != $this->data['user_id'])
     {
@@ -116,9 +121,10 @@
     }
   }
-  
+
   /**
    * updateParam
-   * @param: string param name
-   * @param: mixed param value
+   *
+   * @param string $name
+   * @param mixed $value
    */
   function updateParam($name, $value)
@@ -130,9 +136,10 @@
     }
   }
-  
+
   /**
    * getParam
-   * @param: string param name
-   * @return: mixed param value
+   *
+   * @param string $name
+   * @return mixed
    */
   function getParam($name)
@@ -140,8 +147,9 @@
     return $this->data[$name];
   }
-  
+
   /**
    * getImages
-   * @return: array
+   *
+   * @return int[]
    */
   function getImages()
@@ -149,9 +157,10 @@
     return $this->images;
   }
-  
-  /**
-   * isInSet
-   * @param: int image id
-   * @return: bool
+
+  /**
+   * Check if an image is in the collection.
+   *
+   * @param int $image_id
+   * @return bool
    */
   function isInSet($image_id)
@@ -159,41 +168,45 @@
     return in_array($image_id, $this->images);
   }
-  
+
   /**
    * removeImages
-   * @param: array image ids
+   *
+   * @param int|int[] $image_ids
    */
   function removeImages($image_ids)
   {
-    if (empty($image_ids) or !is_array($image_ids)) return;
-    
+    if (empty($image_ids)) return;
+    if (!is_array($image_ids)) $image_ids = array($image_ids);
+
     $this->images = array_diff($this->images, $image_ids);
-    
+
     $query = '
 DELETE FROM '.COLLECTION_IMAGES_TABLE.'
-  WHERE 
+  WHERE
     col_id = '.$this->data['id'].'
     AND image_id IN('.implode(',', $image_ids).')
 ;';
     pwg_query($query);
-    
+
     $this->updateParam('nb_images', count($this->images));
   }
-  
+
   /**
    * addImages
-   * @param: array image ids
+   *
+   * @param int|int[] $image_ids
    */
   function addImages($image_ids)
   {
-    if (empty($image_ids) or !is_array($image_ids)) return;
-    
+    if (empty($image_ids)) return;
+    if (!is_array($image_ids)) $image_ids = array($image_ids);
+
     $image_ids = array_unique($image_ids);
     $inserts = array();
-    
+
     foreach ($image_ids as $image_id)
     {
       if ($this->isInSet($image_id)) continue;
-      
+
       $this->images[] = $image_id;
       $inserts[] = array(
@@ -202,5 +215,5 @@
         );
     }
-    
+
     mass_inserts(
       COLLECTION_IMAGES_TABLE,
@@ -208,5 +221,5 @@
       $inserts
       );
-      
+
     $query = '
 UPDATE '.COLLECTION_IMAGES_TABLE.'
@@ -218,11 +231,12 @@
 ';
     pwg_query($query);
-      
+
     $this->updateParam('nb_images', count($this->images));
   }
-  
+
   /**
    * toggleImage
-   * @param: int image id
+   *
+   * @param int $image_id
    */
   function toggleImage($image_id)
@@ -237,5 +251,5 @@
     }
   }
-  
+
   /**
    * clearImages
@@ -245,5 +259,5 @@
     $this->images = array();
     $this->updateParam('nb_images', 0);
-    
+
     $query = '
 DELETE FROM '.COLLECTION_IMAGES_TABLE.'
@@ -252,8 +266,9 @@
     pwg_query($query);
   }
-  
+
   /**
    * getCollectionInfo
-   * @return: array
+   *
+   * @return array
    */
   function getCollectionInfo()
@@ -266,10 +281,12 @@
       'DATE_CREATION' => $this->data['date_creation'],
       );
-    
+
     return $set;
   }
-  
-  /**
-   * get share links
+
+  /**
+   * Returns share links
+   *
+   * @return array
    */
   function getShares()
@@ -281,10 +298,10 @@
 ;';
     $result = pwg_query($query);
-    
+
     $shares = array();
     while ($row = pwg_db_fetch_assoc($result))
     {
       $row['expired'] = false;
-      
+
       $row['params'] = unserialize($row['params']);
       if (!empty($row['params']['deadline']))
@@ -293,17 +310,20 @@
         $row['params']['deadline_readable'] = format_date($row['params']['deadline'], true, false);
       }
-      
+
       $row['url'] = USER_COLLEC_PUBLIC . 'view/' . $row['share_key'];
       $row['u_delete'] = USER_COLLEC_PUBLIC . 'edit/' . $this->data['id'] . '&amp;delete_share=' . $row['id'];
       $row['add_date_readable'] = format_date($row['add_date'], true, false);
-      
+
       $shares[] = $row;
     }
-    
+
     return $shares;
   }
-  
-  /**
-   * delete a share
+
+  /**
+   * Delete a share
+   *
+   * @param int $id
+   * @return bool
    */
   function deleteShare($id)
@@ -315,24 +335,26 @@
 ;';
     pwg_query($query);
-    
+
     return pwg_db_changes() != 0;
   }
-  
-  /**
-   * Add a share URL
-   * @param: array
-   *          - share_key
-   *          - password
-   *          - deadline
-   * @return: array errors
+
+  /**
+   * Add a share link
+   *
+   * @param array &$share
+   *          - share_key (will be slugified)
+   *          - password (optional)
+   *          - deadline (optional)
+   * @param bool $abord_on_duplicate
+   * @return array|string errors or full share link
    */
   function addShare(&$share, $abord_on_duplicate=true)
   {
     global $conf, $page;
-    
+
     $errors = array();
-    
+
     $share = array_map('stripslashes', $share);
-    
+
     // check key
     if (empty($share['share_key']) || strlen($share['share_key']) < 8)
@@ -344,5 +366,5 @@
       $share['share_key'] = str2url($share['share_key']);
       $share_key = $this->data['id'].'-'.$share['share_key'];
-      
+
       $query = '
 SELECT id FROM '.COLLECTION_SHARES_TABLE.'
@@ -363,12 +385,11 @@
       }
     }
-    
+
     // filter date
     if (!empty($share['deadline']))
     {
-      $date = DateTime::createFromFormat('Y-m-d H:i', $share['deadline']);
-      $share['deadline'] = $date->format('Y-m-d H:i');
-    }
-    
+      $share['deadline'] = transform_date($share['deadline'], 'Y-m-d H:i', 'Y-m-d H:i');
+    }
+
     // hash password
     if (!empty($share['password']))
@@ -376,5 +397,5 @@
       $share['password'] = sha1($conf['secret_key'].$share['password'].$share_key);
     }
-    
+
     if (empty($errors))
     {
@@ -383,5 +404,5 @@
         'deadline' => @$share['deadline'],
         ));
-      
+
       $query = '
 INSERT INTO '.COLLECTION_SHARES_TABLE.'(
@@ -399,14 +420,15 @@
 ;';
       pwg_query($query);
-      
+
       return USER_COLLEC_PUBLIC . 'view/' . $share_key;
     }
-    
+
     return $errors;
   }
-  
+
   /**
    * Send the collection by email
-   * @param: array
+   *
+   * @param array $comm
    *          - sender_name
    *          - sender_email
@@ -415,50 +437,50 @@
    *          - nb_images
    *          - message
-   * @return: array errors
+   * @return array|true array errors or true
    */
   function sendEmail($comm)
   {
-    global $conf;
-    
+    global $conf, $user;
+
     $errors = array();
-    
+
     $comm = array_map('stripslashes', $comm);
 
-    $comment_action='validate';
+    $comment_action = 'validate';
 
     // check author
     if (empty($comm['sender_name']))
     {
-      array_push($errors, l10n('Please enter your name'));
-      $comment_action='reject';
-    }      
+      $errors[] = l10n('Please enter your name');
+      $comment_action = 'reject';
+    }
     if (empty($comm['recipient_name']))
     {
-      array_push($errors, l10n('Please enter the recipient name'));
-      $comment_action='reject';
-    }
-    
+      $errors[] = l10n('Please enter the recipient name');
+      $comment_action = 'reject';
+    }
+
     // check email
     if (empty($comm['sender_email']))
     {
-      array_push($errors, l10n('Please enter your e-mail'));
-      $comment_action='reject';
-    }
-    else if ( !empty($comm['sender_email']) and !uc_check_email_validity($comm['sender_email']) )
-    {
-      array_push($errors, l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)'));
-      $comment_action='reject';
+      $errors[] = l10n('Please enter your e-mail');
+      $comment_action = 'reject';
+    }
+    else if (!empty($comm['sender_email']) and !email_check_format($comm['sender_email']))
+    {
+      $errors[] = l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)');
+      $comment_action = 'reject';
     }
     if (empty($comm['recipient_email']))
     {
-      array_push($errors, l10n('Please enter the recipient e-mail'));
-      $comment_action='reject';
-    }
-    else if ( !empty($comm['recipient_email']) and !uc_check_email_validity($comm['recipient_email']) )
-    {
-      array_push($errors, l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)'));
-      $comment_action='reject';
-    }
-     
+      $errors[] = l10n('Please enter the recipient e-mail');
+      $comment_action = 'reject';
+    }
+    else if (!empty($comm['recipient_email']) and !email_check_format($comm['recipient_email']))
+    {
+      $errors[] = l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)');
+      $comment_action = 'reject';
+    }
+
     // check content
     if (!empty($comm['message']))
@@ -466,137 +488,109 @@
       $comm['message'] = nl2br($comm['message']);
     }
-    
+
     include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
-    
+
     if ($comment_action == 'validate')
     {
-      // format subject
-      $subject = '['.$conf['gallery_title'].'] '.sprintf(l10n('A photo collection by %s'), $comm['sender_name']);
-      $subject = encode_mime_header($subject);
-            
-      // format expeditor
-      $args['from'] = format_email($comm['sender_name'], $comm['sender_email']);
-      $args['to'] = format_email($comm['recipient_name'], $comm['recipient_email']);
-      
-      // hearders
-      $headers = 'From: '.$args['from']."\n";  
-      $headers.= 'MIME-Version: 1.0'."\n";
-      $headers.= 'X-Mailer: Piwigo Mailer'."\n";
-      $headers.= 'Content-Transfer-Encoding: 8bit'."\n";
-      $headers.= 'Content-Type: text/html; charset="'.get_pwg_charset().'";'."\n";
-            
-      // mail content
-      $content = $this->getMailContent($comm);
-      $content = wordwrap($content, 70, "\n", true);
-      
-      // send mail
-      $result =
-        trigger_event('send_mail',
-          false, /* Result */
-          trigger_event('send_mail_to', $args['to']),
-          trigger_event('send_mail_subject', $subject),
-          trigger_event('send_mail_content', $content),
-          trigger_event('send_mail_headers', $headers),
-          $args
-        );
-      
-      if ($result == false)
-      {
-        array_push($errors, l10n('Error while sending e-mail'));
-      }
-      else
-      {
-        return true;
-      }
-    }
-    
-    return $errors;
-  }
-  
-  /**
-   * get mail content for sendMail()
-   */
-  function getMailContent($params)
-  {
-    global $user, $conf, $template;
-    
-    // switch to guest user
-    $user_save = $user;
-    $user = build_user($conf['guest_id'], true);
-    
-    // get pictures
-    $query = '
+      // switch to guest user for get_sql_condition_FandF
+      $user_save = $user;
+      $user = build_user($conf['guest_id'], true);
+
+      // get pictures
+      $query = '
 SELECT
-    id,
-    file,
-    name,
-    path
+    id, file, name, path
   FROM '.IMAGES_TABLE.' AS i
     JOIN '.IMAGE_CATEGORY_TABLE.' AS ci ON ci.image_id = i.id
-  WHERE id IN ('.implode(',', $this->images).')
-    '.get_sql_condition_FandF(array(
-                'forbidden_categories' => 'category_id',
-                'forbidden_images' => 'id'
-                ),
-              'AND'
-              ).'
+  WHERE id IN ('. implode(',', $this->images) .')
+    '.get_sql_condition_FandF(
+        array(
+          'forbidden_categories' => 'category_id',
+          'forbidden_images' => 'id'
+          ),
+        'AND'
+        ).'
   GROUP BY i.id
-  ORDER BY '.DB_RANDOM_FUNCTION.'()
-  LIMIT '.$params['nb_images'].'
-;';
-    $pictures = hash_from_query($query, 'id');
-    
-    // switch back to current user
-    $user = $user_save;
-    unset($user_save);
-  
-    // picture sinfos
-    set_make_full_url();
-    $tpl_vars = array();
-    foreach ($pictures as $row)
-    {
-      $name = render_element_name($row);
-      
-      $tpl_vars[] = array(
-        'TN_ALT' => htmlspecialchars(strip_tags($name)),
-        'NAME' => $name,
-        'URL' => make_picture_url(array('image_id' => $row['id'])),
-        'THUMB' => DerivativeImage::url(IMG_SQUARE, $row),
+  ORDER BY '. DB_RANDOM_FUNCTION .'()
+  LIMIT '. $comm['nb_images'] .'
+;';
+      $pictures = hash_from_query($query, 'id');
+
+      // switch back to current user
+      $user = $user_save;
+      unset($user_save);
+
+      $share_key = array('share_key'=>'mail-' . substr(sha1($this->data['id'].$conf['secret_key']), 0, 11));
+
+      $tpl_vars = array(
+        'COL_URL' => $this->addShare($share_key, false),
+        'PARAMS' => $comm,
+        'derivative_params' => ImageStdParams::get_by_type(IMG_SQUARE),
         );
-    }
-    
-    // template
-    $mail_css = file_get_contents(dirname(__FILE__).'/../template/mail.css');
-    
-    $share_key = array('share_key'=>'mail-' . substr(sha1($this->data['id'].$conf['secret_key']), 0, 11));
-    
-    $template->assign(array(
-      'GALLERY_URL' => get_gallery_home_url(),
-      'PHPWG_URL' => PHPWG_URL,
-      'UC_MAIL_CSS' => str_replace("\n", null, $mail_css),
-      'MAIL_TITLE' => $this->getParam('name').' ('.sprintf(l10n('by %s'), $params['sender_name']).')',
-      'COL_URL' => $this->addShare($share_key, false),
-      'PARAMS' => $params,
-      'derivative_params' => ImageStdParams::get_by_type(IMG_SQUARE),
-      'thumbnails' => $tpl_vars,
-      ));
-      
-    $template->set_filename('uc_mail', dirname(__FILE__).'/../template/mail.tpl');
-    $content = $template->parse('uc_mail', true);
-  
-    unset_make_full_url();
-    
-    return $content;
-  }
-
-  /**
-   * generate a listing of the collection
+
+      // pictures infos
+      set_make_full_url();
+
+      foreach ($pictures as $row)
+      {
+        $name = render_element_name($row);
+
+        $tpl_vars['THUMBNAILS'][] = array(
+          'TN_ALT' => htmlspecialchars(strip_tags($name)),
+          'NAME' =>   $name,
+          'URL' =>    make_picture_url(array('image_id' => $row['id'])),
+          'THUMB' =>  DerivativeImage::url(IMG_SQUARE, $row),
+          );
+      }
+
+      unset_make_full_url();
+
+      $result = pwg_mail(
+        array(
+          'name' => $comm['recipient_name'],
+          'email' => $comm['recipient_email'],
+          ),
+        array(
+          'subject' => '['.$conf['gallery_title'].'] '.l10n('A photo collection by %s', $comm['sender_name']),
+          'mail_title' => $this->getParam('name'),
+          'mail_subtitle' => l10n('by %s', $comm['sender_name']),
+          'content_format' => 'text/html',
+          'from' => array(
+            'name' => $comm['sender_name'],
+            'email' => $comm['sender_email'],
+            )
+          ),
+        array(
+          'filename' => 'mail',
+          'dirname' => realpath(USER_COLLEC_PATH . 'template'),
+          'assign' => $tpl_vars,
+          )
+        );
+
+      if ($result == false)
+      {
+        $errors[] = l10n('Error while sending e-mail');
+      }
+      else
+      {
+        return true;
+      }
+    }
+
+    return $errors;
+  }
+
+  /**
+   * Generate a listing of the collection
+   *
+   * @param string[] $fields
+   * @return string
    */
   function serialize($params)
   {
-    $params = array_intersect($params, array('id','file','name','url','path','date_creation','collection_add_date','filesize','width','height'));
-    
+    $fields = array_intersect($fields, array('id','file','name','url','path','date_creation','collection_add_date','filesize','width','height'));
+
     $content = null;
-     
+
     // get images infos
     $query = '
@@ -617,5 +611,5 @@
 ;';
     $pictures = hash_from_query($query, 'id');
-    
+
     if (count($pictures))
     {
@@ -623,12 +617,12 @@
       set_make_full_url();
       $root_url = get_root_url();
-      
+
       $fp = fopen('php://temp', 'r+');
-      fputcsv($fp, $params);
-        
+      fputcsv($fp, $fields);
+
       foreach ($pictures as $row)
       {
         $element = array();
-        foreach ($params as $field)
+        foreach ($fields as $field)
         {
           switch ($field)
@@ -653,17 +647,17 @@
         }
       }
-      
+
       rewind($fp);
       $content = stream_get_contents($fp);
       fclose($fp);
-      
+
       unset_make_full_url();
     }
-    
+
     return $content;
   }
-  
-  /**
-   * delete
+
+  /**
+   * Delete the collection
    */
   function delete()
@@ -673,4 +667,2 @@
   }
 }
-
-?>
